/*
    Trabalho Prtico IV - IPDI
    -------------------------
    Anderson de Rezende Rocha <anderson.rocha@ic.unicamp.br>
    Leyza E. Baldo Dorini <leyzad@yahoo.com.br>

    Calculo de desvio padrao em amostragens de uma imagem

    OBSERVAO
    ----------
    Imagem[i,j] = *(Imagem + i * nc + j)
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "imagem.h"
#include "morfo.h"
#include "utils.h"

// Constante para alguma referncia de nmeros muito grandes
#define INFINITO 99999999
// Referncia ao ponteiro /dev/null
#define null 0
// Tamanho da janela
#define TAMJANELA 5

void calcularDesvios(int *imagem, int *imagemSaida, int nl, int nc);
float taxaDispersao(int janela[][TAMJANELA]);

int main (int argc, char *argv[])
{
    int OK, nc, nl, mn;
    int *imagemEntrada;
    int *imagemSaida;

    printf("\nDesvio-padrao <Anderson Rocha, Leyza Dorini>\n");

    if (argc == 3)
    {
        OK = le_imagem_pgm (argv[1], &imagemEntrada, &nl, &nc, &mn);

        info_imagem (argv[1], nl, nc, mn);
        aloca_memo (&imagemSaida, nl, nc);

        calcularDesvios(imagemEntrada, imagemSaida, nl, nc);

        if(imagemEntrada != null)
        {
            grava_imagem_pgm (imagemSaida, argv[2], nl, nc, mn);
            printf("Imagem \"%s\" gravada com sucesso!\n", argv[2]);
        }
        else
        {
            printf("Problemas gravando a imagem\n");
        }

        desaloca_memo(&imagemSaida);
    }
    else
    {
        printf("Sintaxe incorreta\n");
    }

    printf("\n");
    return(0);
}

/*
    imagem = imagem armazenada
    nl = numero de linhas
    nc = numero de colunas
    tmx = tamanho da janela em x
    tmy = tamanho da janela em y
*/
void calcularDesvios(int *imagem, int *imagemSaida, int nl, int nc)
{
    // coluna,  linha, numero de janelas, nro colunas da janela, nro linhas
    int c, l, nj, i, j, k;
    int janela[TAMJANELA][TAMJANELA];
    int x;
    int elementoCentral = 0;
    float desvioPadraoMedio = 0.0;
    int contador = 0;
    int contadorDesvios;

    nj = 0;
    x = 0;
    contadorDesvios = 0;

    for(x = 0; x < nl - TAMJANELA + 1; x++)
    {
        for(nj = 0; nj < nc - TAMJANELA + 1; nj++)
        {
            k = nj + x * nc;
            l = 0;
            contador = 0;

            for(i = 0; i < TAMJANELA; i++)
            {
                c = 0;
                for(j = k; j < (TAMJANELA + k); j++)
                {
                    contador++;
                    janela[l][c] = *(imagem + j);
                    c++;

                    if(contador == (TAMJANELA * TAMJANELA / 2) + 1)
                        elementoCentral = j;

                }
                k = (k + nc);
                l++;
            }

            desvioPadraoMedio = desvioPadraoMedio + taxaDispersao(janela);
            contadorDesvios++;
            //printf("Desvio da regiao = %f\n", desvioPadraoMedio);
        }
    }

    printf("Desvio total da imagem = %f\n", desvioPadraoMedio);
    desvioPadraoMedio = desvioPadraoMedio / contadorDesvios;
    printf("Desvio medio da imagem = %f\n", desvioPadraoMedio);
    printf("Contador de desvios = %d\n", contadorDesvios);
}

float taxaDispersao(int janela[][TAMJANELA])
{
    int i, j, nroElementos;
    float variancia, media, soma;

    variancia = 0.0;
    media = 0.0;
    soma = 0.0;
    nroElementos = TAMJANELA * TAMJANELA;

    // Calcula a soma
    for(i = 0; i < TAMJANELA; i++)
        for(j = 0; j < TAMJANELA; j++)
            soma = soma + (float)(janela[i][j]);

    media = soma / (nroElementos);

    for(i = 0; i < TAMJANELA; i++)
        for(j = 0; j < TAMJANELA; j++)
            variancia += pow((janela[i][j] - media), 2);

    variancia = variancia / (nroElementos);

    /*for(i = 0; i < TAMJANELA; i++)
    {
        for(j = 0; j < TAMJANELA; j++)
            printf("%d ", janela[i][j]);

        printf("\n");
    }

    printf("\n");*/

    return sqrt(variancia);
}
